use Config;
use vars qw($STATE_FILE $RH_VARS);
use File::Basename qw(basename dirname);
chdir(dirname($0));
($file = basename($0)) =~ s/\.PL$/\.cgi/;
open OUT,">$file" or die "Can't create $file: $!";
chmod(0755, $file);
###########################################################################
#                   cludge to get variables in                            #
###########################################################################
$STATE_FILE       = "../.nhgri_src_dir";
$RH_VARS = read_variables_from_file();

###########################################################################
sub read_variables_from_file {
    my $error  = "cannot open $STATE_FILE\nDID YOU run ";
       $error .= "the install script FIRST?:$!";
    my ($v,@variables,%vars,$key);
    my $count = 1;

    open IN,$STATE_FILE or die $error;
    chomp(@variables = <IN>);
    foreach $v (@variables) {
        if ($count % 2) {
            $key = $v;
        } else {
            $vars{$key} = $v;
        }
        $count++;
    }
    return \%vars;
}

print "Extracting $file (with variable substitutions)\n";

print OUT <<"!GROK!THIS!";
$Config{'startperl'} -T

!GROK!THIS!

print OUT <<'!NO!SUBS!';
require 5.004;

use strict;
use Carp;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use URI::Escape qw(uri_escape);
use vars qw($VERSION $WEB_BLAST_PATH $URL $LOGO $INDEX_FILE $ICON_LOCATION 
            $WB_HOME_BUTTON $DB_HOME_BUTTON $HITS_TABLE_BUTTON 
            $EMAIL_BUTTON %BLASTS $SUMMARY_FILE $COMMENTS_FILE 
            $ADMIN_EMAIL $RED_BUTTON $BLUE_BUTTON $SCF_PROGRAM
            $SCF_SUFFIX $TRACE_SUFFIX $DELIMITER $LIT_DELIMITER %BLAST_POSITIONS
            $PRESENT_PROJECT_CHOOSER $PROJECT_PATH $PROJECT_DIR 
            $PROJECT_SETUP_SUFFIX $PROJECT_INDEX_SUFFIX $DEFAULT_SORT_FIELD);

$PRESENT_PROJECT_CHOOSER = 1; # 0 disallows the project chooser

###########################################################################
#   GLOBAL VARIABLES:  You may want to adjust these variables.            #
###########################################################################
!NO!SUBS!

print OUT <<"!GROK!THIS!";
\$WEB_BLAST_PATH          = '$RH_VARS->{'webblast_root'}';
\$ICON_LOCATION           = '$RH_VARS->{'webblast_url'}/images';
\$ADMIN_EMAIL             = '$RH_VARS->{'admin_email'}';
\$ENV{'STADENROOT'}       = '$RH_VARS->{'stadenroot'}';
!GROK!THIS!

print OUT <<'!NO!SUBS!';
###########################################################################
#  PUBLIC DOMAIN NOTICE                                                   #
###########################################################################
#  This software/database is "United States Government Work" under the
#  terms of the United States Copyright Act. It was written as part of
#  the authors' official duties for the United States Government and thus
#  cannot be copyrighted. This software/database is freely available to
#  the public for use without a copyright notice. Restrictions cannot
#  be placed on its present or future use.
#
#  Although all reasonable efforts have been taken to ensure the
#  accuracy and reliability of the software and data, the National
#  Human Genome Research Institute (NHGRI) and the U.S.  Government
#  does not and cannot warrant the performance or results that may be
#  obtained by using this software or data. NHGRI and the U.S.
#  Government disclaims all warranties as to performance,merchantability 
#  or fitness for any particular purpose.
#
#  In any work or product derived from this material, proper
#  attribution of the authors as the source of the software or
#  data should be made, using http://genome.nhgri.nih.gov/blastall
#  as the citation.
###########################################################################


###########################################################################
#   USER SHOULD NOT HAVE TO ADJUST ANYTHING BELOW HERE
###########################################################################
$VERSION           = "2.00.5";
$SCF_PROGRAM       = "makeSCF";
$SCF_SUFFIX        = "scf";
$TRACE_SUFFIX      = "Trace";

$PROJECT_DIR = 'projects';
$PROJECT_PATH = "$WEB_BLAST_PATH/$PROJECT_DIR";
$PROJECT_SETUP_SUFFIX = "setup";
$PROJECT_INDEX_SUFFIX = "index";
$DEFAULT_SORT_FIELD = 'scores';

$LOGO              = "$ICON_LOCATION/webblast.gif";
$WB_HOME_BUTTON    = "$ICON_LOCATION/home.gif";
$DB_HOME_BUTTON    = "$ICON_LOCATION/db_home.gif";
$HITS_TABLE_BUTTON = "$ICON_LOCATION/hits_table.gif";
$EMAIL_BUTTON      = "$ICON_LOCATION/email.gif";
$BLUE_BUTTON       = "$ICON_LOCATION/blue_button.gif";
$RED_BUTTON        = "$ICON_LOCATION/red_button.gif";
$SUMMARY_FILE     = "codes.summary";
$COMMENTS_FILE     = "comments.dat";
$LIT_DELIMITER     = '~|~';
$DELIMITER         = '~\|~';
%BLAST_POSITIONS   = ( 'suffix'         => 0,
                       'id'             => 1,
                       'defline'        => 2, 
                       'length'         => 3,
                       'scores'         => 4,
                       'expects'        => 5,
                       'identities'     => 6,
                       'match_lengths'  => 7,
                       'positives'      => 8, 
                       'gaps'           => 9,
                       'query_starts'   => 10, 
                       'subject_starts' => 11
                    );

my $q = new CGI;
$URL = $q->url;

main($q);

###########################################################################
#                            sub main                                     #
###########################################################################
sub main {
    my $q = shift;
    my $project = $q->param('project') || "";
    my $sample_name = $q->param('sample_name') || "";

    if ($q->param('html')) {
        print_html($project);
    } elsif ($q->param('from_project_picker')) {
        print_database_picker($project);
    } elsif ($q->param('from_project_textbox')) {
        check_if_project_exists($project);
        print_database_picker($project);
    } elsif ($q->param('download_collection')) {
        download_collection();
    } elsif ($q->param('comment_button')) {
        print_comment_header();
        print_comment();
    } elsif ($sample_name ne "") {
        print_sequence_provided($project);
    } elsif ($q->param('show_sequence')) {
        add_comment($project) if ($q->param('from_comment_form'));
        print_sequence_detail($project);
    } elsif ($q->param('from_comment_form')) {
        add_comment($project);
    } elsif ($q->param('from_chooser')) {
        print_codes($project);
    } elsif ($q->param('from_db_picker')) {
        print_chooser($project);
    } else {
        if ($project) {
            print_database_picker($project);
        } elsif ($PRESENT_PROJECT_CHOOSER) {
            present_project_chooser();
        } else {
            present_project_textbox();
        }
    } 
}

###########################################################################
#                    sub check_if_project_exists                          #
###########################################################################
sub check_if_project_exists {
    my $project = shift;
    if (-d "$PROJECT_PATH/$project") {
        return 1;
    } else {
        print_header("Error - No such project: $project");
        print "<CENTER><H3>No such project: $project</H3>\n";
        print qq!Try Again <P>
                 <FORM METHOD="get"><BR>
                 <B>Project Name (case sensitive):</B> <INPUT NAME="project">
                 <INPUT TYPE="submit" NAME="from_project_textbox" 
                             VALUE="Enter Project"></FORM>
                  </CENTER></BODY></HTML>\n!;
    exit;
    }
}

###########################################################################
#                      sub present_project_chooser                        #
###########################################################################
sub present_project_chooser {
    opendir (DIR, $PROJECT_PATH);
    my @allfiles = grep (!/^\.\.?$/, readdir(DIR));
    closedir (DIR);
  
    print_header("Pick a Project");
    print qq!<CENTER><H2>Pick a Project</H2><FORM METHOD="get"><BR>
             <SELECT NAME="project">!;
    foreach (@allfiles) {
        if (-d "$PROJECT_PATH/$_") {
            print qq!<OPTION VALUE="$_">$_\n!;
        }
    } 
    print qq!</SELECT><INPUT TYPE="submit" NAME="from_project_picker" 
                             VALUE="Enter Project"></FORM>\n!;
    print qq!</CENTER></BODY></HTML>\n!;
}

###########################################################################
#                       sub present_project_textbox                       #
###########################################################################
sub present_project_textbox {
    print_header("Enter a Project");
    print qq!<CENTER><H2>Enter a Project</H2><FORM METHOD="get"><BR>
             <B>Project Name (case sensitive):</B> <INPUT NAME="project">!;
    print qq!<INPUT TYPE="submit" NAME="from_project_textbox" 
                             VALUE="Enter Project"></FORM>\n!;
    print qq!</CENTER></BODY></HTML>\n!;
}

###########################################################################
#                    sub print_sequence_provided                          #
###########################################################################
#   PRINTS out the results of the search_index subroutine (described below)
#   If search_index returns 1 hit, it calls print_sequence_detail (described
#   below) and prints out the sequence detail page. If search_index returns
#   2+ hits, it returns a list of all hits. If no hits are returned, it
#   prints out a no-hit message.
###########################################################################
sub print_sequence_provided {
    my $project = shift;
    my $database = $q->param('database');
    my $sample_name = $q->param('sample_name');
    my $ra_rec = search_index($project,$database,$sample_name);
    my $search_hits = scalar(@$ra_rec);
    my (@fields,$hit,$url);

    if (ref($ra_rec) eq "ARRAY") {
        if ($search_hits == 1) {
            @fields = split /\//, $ra_rec->[0];
            print_sequence_detail($project,$fields[2],$fields[0],$fields[1]);
            # call sub sending (@fields);
        } elsif ($search_hits >= 2) {
            print_header("$search_hits Matches to $sample_name");
            print qq^<HR><FONT SIZE=4><B>$search_hits Matches to 
            $sample_name</B></FONT><HR>
            <BLOCKQUOTE>^;
            foreach $hit (@$ra_rec) {
                @fields = split /\//, $hit;
                $url = return_url($project,$fields[2],$fields[0],$fields[1]);
                print_link($url,$fields[2]);
            }
            print "</BLOCKQUOTE><HR>\n";
            print_button_bar($project);
        } else {
            print_header("0 Results found for $sample_name");
            print qq^
            <HR WIDTH=90%>
            <BR>
            <BR>
            <CENTER>
            <BLOCKQUOTE>
            <FONT SIZE=4><B>Sorry, there are no sample names that match 
            your search criteria.</B></FONT>
            <BR>
            <BR>
            <BR>
            </BLOCKQUOTE>
            <HR WIDTH=90%>
            </CENTER>^;
            print_button_bar($project);
#            print_button_bar("no_match");
        }
    }
}

###########################################################################
#                             sub print_link                               #
###########################################################################
#   ACCEPTS a url and a sample name
#   RETURNS a formatted link
###########################################################################
sub print_link {
    my $url = shift;
    my $sample_name = shift;

    print qq!
    <LI><A HREF="$url">$sample_name</A>
    !;
}

###########################################################################
#                            sub return_url                               #
###########################################################################
#   ACCEPTS a sequence id, database and directory
#   RETURNS a properly escaped (uri_escape) and formatted url
###########################################################################
sub return_url {
    my $project = shift;
    my $sequence_id = shift;
    my $database = shift;
    my $selection = shift;
    $sequence_id = uri_escape($sequence_id);
    $database = uri_escape($database);
    $selection = uri_escape($selection);
    my $url = $q->url;
    $url .= "?project=$project&show_sequence=$sequence_id&database=$database";
    $url .= "&selection=$selection";
    return $url;
}

###########################################################################
#                             sub search_index                             #
###########################################################################
#   ACCEPTS a database and a sample name
#   It opens an index file and searches (using regular expressions) for
#   records that match the database and sample name
#   RETURNS a reference to an array of found records
###########################################################################
sub search_index {
    my $project = shift;
    my $database = shift;
    my $sample_name = shift;
    my (@rec);
    
    # added this so that from the users perspective * will work like .*
    # and match any character(s)
    $sample_name =~ s/\*/\.\*/g;

    open INDEX, "$PROJECT_PATH/$project/$project.$PROJECT_INDEX_SUFFIX" or 
    croak "cannot open $PROJECT_PATH/$project/$project.$PROJECT_INDEX_SUFFIX:$!";
    while (<INDEX>) {
        chomp;
        my @sfields = split(/\//, $_);
        if ($sfields[0] =~ /$database/ && $sfields[2] =~ /$sample_name/i) {
            push @rec,$_;
        }
    }
    if (defined @rec) {
        return \@rec;
    } else {
        @rec = ();
        return \@rec;
    }
}

###########################################################################
#                            sub by_hash_index                            #
###########################################################################
sub by_hash_index {
    return $BLASTS{$a}->[0] <=> $BLASTS{$b}->[0];
}

###########################################################################
#                        sub print_sequence_detail                        #
###########################################################################
sub print_sequence_detail {
    my $project = shift;
    my ($seq_id,$db,$selection,$scf_file);
    if (@_) {
        ($seq_id,$db,$selection) = @_;
    } else {
        $seq_id = $q->param('show_sequence') || $q->param('seq_id');
        $db = $q->param('database');
        $selection = $q->param('selection');
        $scf_file = $q->param('scf_file') || 0;
    }

    my $rh_codes = get_codes("$PROJECT_PATH/$project/$db/$selection/$seq_id/$seq_id.codes");
    my $raw_seq = get_sequence("$PROJECT_PATH/$project/$db/$selection/$seq_id/$seq_id.Seq");
    my $masked_seq = get_sequence("$PROJECT_PATH/$project/$db/$selection/$seq_id/$seq_id.fa.mask");

    print_sequence_header($seq_id);
    print_graphical_viewer_tags($project,$db,$selection,$seq_id,
                                $rh_codes,$raw_seq);
    print_part_one($project,$db,$selection,$seq_id,
                 $rh_codes,$raw_seq,$masked_seq);
    print_hits($project,$db,$selection,$seq_id,$rh_codes);
    print "<P>";
    print_comment("no-auto-close", $seq_id, $selection); 
    print_button_bar($project);

    if ($scf_file) {
        display_trace($project,$scf_file,$seq_id,$db,$selection);
    }
}
###########################################################################
#                       sub print_graphical_viewer_tags                   #
###########################################################################
sub print_graphical_viewer_tags {
    my $project = shift;
    my $db = shift;
    my $selection = shift;
    my $seq_id = shift;
    my $rh_codes = shift;
    my $seq = shift;
    my ($have_hits,$seq_count,$hsp,$defline);
    my $hits = 0;
    $seq =~ s/[<BR>|\n]//g;
    $seq_count = length($seq);
    my $delimiter = '^^';  
    my $qs_n = $BLAST_POSITIONS{'query_starts'} - 1;
    my $ml_n = $BLAST_POSITIONS{'match_lengths'} - 1;
    my $dl_n = $BLAST_POSITIONS{'defline'} - 1;
    my $id_n = $BLAST_POSITIONS{'id'} - 1;

    my $param_tag = qq!<CENTER><APPLET CODE="GraphicalViewer.class" 
        CODEBASE="java/graphicalviewer/" WIDTH=525 HEIGHT=300>
       <PARAM NAME="querylength" VALUE="773">\n!;

#   Uncomment these lines to use the jar files...
#    my $param_tag = qq!<CENTER><APPLET CODE="GraphicalViewer.class" 
#        ARCHIVE="java/graphicalviewer/graphicalviewer.zip,
#                 java/graphicalviewer/graphicalviewer.jar" 
#        WIDTH=525 HEIGHT=300><PARAM NAME="querylength" VALUE="773">\n!;
 
    foreach my $k (keys %$rh_codes) {
        foreach my $r (@{$rh_codes->{$k}}) {
            $defline = unspace_defline($r->[$dl_n]);
            $param_tag .= qq!<PARAM NAME="hit$hits" VALUE="$k$delimiter!;
            $param_tag .= $r->[$qs_n] . $delimiter . $r->[$ml_n] . $delimiter;
            $param_tag .= $defline . $delimiter;
            $param_tag .= qq!$URL?html=$project/$db/$selection/$seq_id/$seq_id.$k.html#$r->[$id_n]">\n!;
            $hits++
        }
    }
    $param_tag .= "</APPLET></CENTER>";
    print $param_tag if ($hits);
}

###########################################################################
#                            sub print_hits                               #
###########################################################################
#   In tables we only want a hsp listed once.  In the traceviewer
#   we allow multiple hits from the same sequence to show up.
#   hence (%listed_idents).
###########################################################################
sub print_hits {
    my $project          = shift;
    my $db               = shift;
    my $selection        = shift;
    my $seq_id           = shift;
    my $rh_codes         = shift;
    my $field_to_sort_by = $q->param('sort_by') || $DEFAULT_SORT_FIELD;
    my $s                = $BLAST_POSITIONS{$field_to_sort_by} - 1;
    my $def_n            = $BLAST_POSITIONS{'defline'} - 1;
    my $ident_n          = $BLAST_POSITIONS{'identities'} - 1;
    my $score_n          = $BLAST_POSITIONS{'scores'} - 1;
    my $expect_n         = $BLAST_POSITIONS{'expects'} - 1;
    my $id_n             = $BLAST_POSITIONS{'id'} - 1;
    my ($defline,$ident,$score,$expect,@sorted);

    $seq_id =~ s/%/%25/g;
    foreach my $k (keys %$rh_codes) {
        print_table_header($project,$db,$selection,$seq_id,$k);
        
        if ($field_to_sort_by eq "expects") {
            @sorted = sort { $a->[$s] <=> $b->[$s] } @{$rh_codes->{$k}};
        } else {
            @sorted = sort { $b->[$s] <=> $a->[$s] } @{$rh_codes->{$k}};
        }

        my %listed_seq = ();
        foreach my $r (@sorted) {
            $defline = truncate_defline($r->[$def_n]);
            $ident = _round_identities($r->[$ident_n]);
            $score = $r->[$score_n];
            $expect = $r->[$expect_n];
            next if ($listed_seq{$r->[$id_n]});  
            print qq!<TR><TD><TT>
                 <A HREF="$URL?project=$project&html=$db/$selection/$seq_id/!;
            print qq!$seq_id.$k.html#$r->[$id_n]">$r->[$id_n]</A></TT></TD>
                         <TD><TT>$defline</TT></TD>
                         <TD><TT>$score</TT></TD>
                         <TD><TT>$expect</TT></TD>
                         <TD><TT>$ident</TT></TD></TR>!;
            $listed_seq{$r->[$id_n]} = 1;
        }
        print qq!</TABLE><P>\n!;
    }
}

###########################################################################
#                             sub round_identities                        #
###########################################################################
sub _round_identities {
    my $ident = shift;
    my $rounded = sprintf("%.2f", $ident);
    return $rounded;
}

###########################################################################
#                      sub unspace_deflines                               #
###########################################################################
sub unspace_defline {
    my $dl = shift;
    $dl =~ s/\s\s+/\s/g;
    return $dl;
}

###########################################################################
#                           sub truncate_defline                          #
###########################################################################
sub truncate_defline {
    my $dl = shift;
    $dl = unspace_defline($dl);
    $dl = substr($dl,0,30);
    $dl .= "...";
    return $dl;
}

###########################################################################
#                          sub print_part_one                             #
###########################################################################
sub print_part_one {
    my $project    = shift;
    my $db         = shift;
    my $selection  = shift;
    my $seq_id     = shift;
    my $rh_codes   = shift;
    my $raw_seq    = shift;
    my $masked_seq = shift; 
    my $path_to_scf;

    print qq!<CENTER><TABLE CELLPADDING=5><TR><TD>
                 <TABLE BORDER=0 WIDTH=60>
                 <TR><TD><FONT SIZE=-1><B>Raw Sequence</B></FONT></TD>
                 <TR><TD><FONT SIZE=-2><TT>$raw_seq</TT></FONT></TD>
                 <TR><TD><FONT SIZE=-1><B>Masked Sequence</B></FONT></TD>
                 <TR><TD><FONT SIZE=-2><TT>$masked_seq</TT></FONT></TD>
                 </TR></TABLE>
              </TD><TD>
                 <TABLE BORDER=1><TR><TD>\n!;
    if ($ENV{'STADENROOT'}) {
        $URL =~ m/^(.*)\/.*$/;
        $path_to_scf  = "$1/$PROJECT_DIR/$project/$db/$selection/";
        $path_to_scf .= "$seq_id/$seq_id.$SCF_SUFFIX";

        print qq!
            <TABLE BORDER=0><TR><TD ALIGN="center">
            <B>Display Trace</B></TD></TR>
            <TR><TD ALIGN="center" VALIGN="center" BGCOLOR="#cccccc">
            <FORM METHOD="get"> 
            <INPUT TYPE="hidden" NAME="project" VALUE="$project">
            <INPUT TYPE="hidden" NAME="database" VALUE="$db">
            <INPUT TYPE="hidden" NAME="selection" VALUE="$selection">
            <INPUT TYPE="hidden" NAME="show_sequence" VALUE="$seq_id">
            <INPUT TYPE="hidden" NAME="auto_close" VALUE=0>
            <INPUT TYPE="hidden" NAME="scf_file" VALUE="$path_to_scf">
            <INPUT TYPE="submit" NAME="from_trace_display" 
                   VALUE="Launch Trace Viewer"></FORM>
            </TR></TD></TABLE>\n!;
    } else {
        print '&nbsp;';
    }
    print qq!
        </TR><TR><TD>    
            <TABLE BORDER=1 WIDTH="100%" CELLPADDING=3>
            <TR><TH COLSPAN=2>Results</TH></TR>\n!;

    print_mini_hits_table($project,$db,$selection,$seq_id);
     print qq!
         </TABLE></TD></TR></TABLE>
         </TD></TR></TABLE></CENTER>\n!;
}

###########################################################################
#                       sub print_mini_hits_table                         #
###########################################################################
sub print_mini_hits_table {
    my $project = shift;
    my $db = shift;
    my $selection = shift;
    my $seq_id = shift;
    my $file = "$PROJECT_PATH/$project/$db/$selection/$SUMMARY_FILE";

    open IN, $file or croak "cannot open $file:$!"; 
    my @header = split /$DELIMITER/,<IN>;
    my @counts = ();

    while (<IN>) {
        next unless (/^$seq_id/);
        @counts = split /$DELIMITER/,$_;
        chomp $counts[$#counts];
        last;
    }

    for (my $i=0; $i <= $#header; $i++) {
        next if ($counts[$i] eq $seq_id); 
        if ($counts[$i]) {
            print qq!<TR><TD BGCOLOR="#cccccc">
                         <A HREF="#$header[$i]">$header[$i]</A></TD>\n!;
        } else {
            print qq!<TR><TD BGCOLOR="#cccccc">
                          <A HREF="$URL?project=$project&html=$db/$selection/$seq_id/$seq_id.$header[$i].html">$header[$i]</A></TD>\n!;
        }
        print qq!<TD ALIGN="center" BGCOLOR="#cccccc">$counts[$i]</TD></TR>\n!;
    }
}

###########################################################################
#                        sub print_table_header                           #
###########################################################################
sub print_table_header {
    my $project = shift;
    my $database = shift;
    my $selection = shift;
    my $seq_id = shift;
    my $k = shift;
    my $link = "$database/$selection/$seq_id/$seq_id.$k.html";
    my $url = $q->url;

    print qq!<A NAME="$k">
             <TABLE BORDER=2 WIDTH="100%"><TR>
                 <TH COLSPAN=5><FONT SIZE=+3><B><A HREF="$url?project=$project&html=$link">$seq_id.$k</A></B>
                     </FONT></TH></TR>
             <TR><TD COLSPAN=2><FONT SIZE=-1><B><CENTER>Sequences 
                     producing significant alignments</CENTER></B></FONT></TD>
                 <TD ALIGN="center"><FONT SIZE="-1"><B><A HREF="$URL?project=$project&show_sequence=$seq_id&database=$database&selection=$selection&sort_by=scores">Score<BR>(bits)</A></B></FONT></TD>
                 <TD ALIGN="center"><FONT SIZE="-1"><B><A HREF="$URL?project=$project&show_sequence=$seq_id&database=$database&selection=$selection&sort_by=expects">E<BR>value</A></B></TD></FONT>
                 <TD ALIGN="center"><FONT SIZE="-1"><B><A HREF="$URL?project=$project&show_sequence=$seq_id&database=$database&selection=$selection&sort_by=identities">Identities<BR>(percent)</A></B></TD></FONT></TR>
         !;
}

###########################################################################
#                             sub get_codes                               #
###########################################################################
sub get_codes {
    my $code_file = shift;
    my %records = ();
    my $id;

    open IN, "$code_file" or carp "cannot open $code_file:$!";
    while (<IN>) {
        my @fields = split /$DELIMITER/;
        $id = shift @fields;
        $records{$id} = [] unless $records{$id};
        push @{$records{$id}}, \@fields;
    }
    return \%records;
}

###########################################################################
#                          sub display_trace                               #
###########################################################################
sub display_trace {
    my $project = shift;
    my $scf_file = shift;
    my $seq_id = shift;
    my $database = shift;
    my $selection = shift;
    my $path_to_scf = "$PROJECT_PATH/$project/$database/$selection/$seq_id/$seq_id.scf";
#    my $path_to_scf = "$PROJECT_PATH/$project/$database/$selection/$seq_id/$seq_id.scf";
    if (-s $path_to_scf) {
        print qq!
        <APPLET CODE="TViewLauncher.class" CODEBASE="java/traceviewer" HEIGHT=0 WIDTH=0>
        <PARAM NAME="file" VALUE="$scf_file">
        </APPLET>
        !;
    } else {
        $ENV{'PATH'} = "/bin:/usr/bin";
        set_staden_env();
        my $path = "$PROJECT_PATH/$project/$database/$selection/$seq_id";
        my $scf_path = "$ENV{'STADENROOT'}/$ENV{'MACHINE'}-bin";
        my $pro = untaint_data($project);
        my $seq = untaint_data("$seq_id");
        my $db = untaint_data("$database");
        my $sel = untaint_data("$selection");
        my $tf_in = "$PROJECT_PATH/$pro/$db/$sel/$seq/$seq.$TRACE_SUFFIX";
        my $tf_out = "$PROJECT_PATH/$pro/$db/$sel/$seq/$seq.$SCF_SUFFIX";
        my @args = ("$scf_path/$SCF_PROGRAM",
                    "-8",
                    "-s",
                    "-abi",
                    "$tf_in",
                    "-output",
                    "$tf_out");
        system(@args);

        if (-s $path_to_scf) {
            print qq!
            <APPLET CODE="TViewLauncher.class" CODEBASE="java/traceviewer" HEIGHT=0 WIDTH=0>

            </APPLET>!;
        } else {
            print qq!
            <SCRIPT LANGUAGE=JavaScript>
            var msg = "TraceViewer cannot display trace information:  \\n";
                msg += "- File $seq.$TRACE_SUFFIX contains bad data.\\n";
            alert(msg);
            </SCRIPT>!;
        }
    }
}

###########################################################################
#                          sub get_high_light                             #
###########################################################################
#   ACCEPTS a value and a color
#   RETURNS the value in the that color
###########################################################################
sub get_high_light {
    my $value = shift;
    my $cellcolor = shift;
    my ($cellvalue);

    $cellvalue = qq^<FONT COLOR="$cellcolor">$value</FONT>^;

    return $cellvalue;
}

###########################################################################
#                       sub print_sequence_header                         #
###########################################################################
#   ACCEPTS a sequenceID, a raw sequence and a masked sequence
#   prints out the HEADER of the SEQUENCE PAGE
###########################################################################
sub print_sequence_header {
    my $seq_id = shift;

    print qq!Content-type: text/html

    <HTML>
    <HEAD>
    <TITLE>Results for $seq_id</TITLE>!;
    print qq!
    </HEAD>
    <BODY BGCOLOR="#ffffff">
    <CENTER>
    
    <TABLE BORDER=4 WIDTH=500>
    <TR>
        <TH><TABLE>
        <TR>
        <TD><A HREF="$URL"><IMG SRC="$LOGO" BORDER=0 
             ALT="NHGRI WEB_BLAST">
            </A></TD>
        </TR>
        </TABLE></TH>
    </TR>
    </TABLE>
    
    <H2>Results for $seq_id</H2></CENTER>
    !;
    
}

###########################################################################
#                         sub get_sequence                                 #
###########################################################################
#   In most cases the sequence is on one line
#   However sometimes it has line breaks depending on the format so we
#      concatinate.
#   Also if the seq is in FASTA format, we don't want the first line which
#      starts with `>'
###########################################################################
sub get_sequence {
    my $seq_file = shift;
    my $seq = "";
    my $clean_seq = "";
    my $sixty = "";
    
    open SEQ, "$seq_file" or croak "cannot open $seq_file:\n$!\n";
    while (<SEQ>) {
        unless (/>/) {
            chomp;
            $seq .= $_;
        }
    }
    while (length($seq) > 60) {
        $sixty = substr ($seq, 0, 60);
        $clean_seq .= "$sixty<BR>\n";
        $seq = substr ($seq, 60);
    } 
    $clean_seq .= $seq;

    close SEQ;
    return $clean_seq;
}

###########################################################################
#                         sub add_comment                                 #
###########################################################################
#   OPENS the comments.dat file for the particular database/directory that
#   the sequence comes from
#   If the comments file does not exist, it is created and the comment is
#   written to that file
#   If the comments file exists, the comment is appended to that file
#   If this is called from a popup comment window on the hits table, it
#   calls close_window to close the popup window
###########################################################################
sub add_comment {
    my $project = shift;
    my $comments = $q->param('comments');
    my $selection = $q->param('selection');
    my $seq_id = $q->param('seq_id') || $q->param('show_sequence');
    my $database = $q->param('database');
    my $auto_close = $q->param('auto_close');
    $comments =~ s/\n//g;
    my $codes = "";
    my $found = 0;
    my @recs = ();

    $database = untaint_data($database);
    $selection = untaint_data($selection);
    $project = untaint_data($project);
    my $c_file = "$PROJECT_PATH/$project/$database/$selection/$COMMENTS_FILE"; 


    if (-s "$c_file") {
        open COMMENTS, $c_file or croak "cannot open $c_file:$!"; 
        while (<COMMENTS>) {
            if (/^$seq_id$DELIMITER/) {
                chomp;
                @recs = split /$DELIMITER/;
                $codes .= $seq_id . $LIT_DELIMITER . $comments . "\n";
                $found = 1;
            } else {
                $codes .= $_;
            }
        }
        close COMMENTS;
        
        $codes .= $seq_id . $LIT_DELIMITER . $comments . "\n" unless ($found);
        open COMMENTS, ">$c_file" or croak "cannot open $c_file:$!";
        print COMMENTS $codes;
        close COMMENTS;
    } else {
        open COMMENTS, ">$c_file" or croak "cannot open $c_file:$!";
        print COMMENTS "$seq_id$LIT_DELIMITER$comments\n";
        close COMMENTS;
    }
    
     close_window() if ($auto_close);
}

###########################################################################
#                          sub close_window                               #
###########################################################################
#   PRINTS out an HTML page that closes itself
###########################################################################
sub close_window {
    print qq!Content-type: text/html

    <HTML><HEAD><TITLE></TITLE></HEAD>
    <BODY BGCOLOR="#ffffff" onLoad="window.close(self)">
    </BODY></HTML>!;
}

###########################################################################
#                      sub print_comment_header                           #
###########################################################################
#   PRINTS out the header for a popup comment window
###########################################################################
sub print_comment_header {
    my $seq_id = $q->param('seq_id');

    print qq!Content-type: text/html

    <HTML>
    <HEAD>
    <TITLE>Blast Comment</TITLE>
    
    </HEAD>
    <BODY BGCOLOR="#ffffff">
    <CENTER><FONT SIZE=+1>Comments for $seq_id</FONT></CENTER>
    !;
}

###########################################################################
#                            sub print_comment                            #
###########################################################################
#   PRINTS out the beginning of the comment form (for the popup comment 
#   window and the sequence detail page)
#   If the string "auto_close" is sent to this sub, the resulting form 
#   will automatically close when submitted.
#   This is done by setting the hidden variable auto_close to 1 
#   If set to 0 it won't close.
###########################################################################
sub print_comment {
    my $auto_close = shift;
    my $seq_id = $q->param('seq_id') || shift;
    my $project = $q->param('project');
    my $selection = $q->param('selection') || shift; 
    my $database = $q->param('database');
    my $autoent_headt_come0;
    my @recc);
 s)   print qq!
    <LI>< METHOD="get"> 
  
<INPUT TYPE="hidden" NAME="project" VALUUE="$project">
        UT TYPE="hidden" NAME="database" VALUE="$db">
ase" VAL      UT TYPE="hidden" NAME="dataction" VALUE="$selection">
        !   my $$q->param('comment_button')) {
        print_com
        <APPLT TYPE="hidden" NAME="datact");
 UE="$seq_id">
            UT TYPE="hidden" NAME="auto_close" VALUE=0>
 1          UER>
               } else {
        print '&nb        <APPLT TYPE="hidden" NAME="datacsequence" VALUE="$seq_id">
            UT TYPE="hidden" NAME="auto_close" VALUE=0>
            UER>
               } els  if (-s "$c_fiECT_PATH/$project/$database/$selection/$COMMENTS_FILE"; 

        open COMMENTS, $c_f
        "$tf_oECT_PATH/$project/$database/$selection/$COMMENTS_FILE"; 

             $roak "cannot open $c_f             $oECT_PATH/$project/$database/$seleENTS_FILE"; 
;
        prine (<COMMENTS>) {
            if (p;
                /^$seq_id$DELIMITER/) {
                choms = split /$DELIMITER/;
                $codt_comment_head 
# (ords);
                prinoent_headt_come0;
 1              prin;
    }

     }
        }
        close COMMENTS;
          if (defi!oent_headt_come0        print_comment_head 
# (        
###########################################################################
#                        sub print_tablent_head 
#                        #
###########################################################################
#   PRINTS out the begiactualment form (for the popup comment 
#  ow and the the sequence comeil page)
#   ########################################################################
sub print_comment_head (for{ my $autoent_heahift @fie";
    my $sampent_head (for=

    if (pent_head (for=
    <LI><TEXTAREASPAN==40 ROWS=8E="autoents\n";ountst</TITLEEXTAREA  <BODY R>UT TYPE="hidden" NAME="auto_comment_form')) 
      E="$seq      #
##Stted.ment</TI        "$tf_      UT TYPE="hiddit" NAME="fromuseen" NAtag
      E="$seq      #
##Stted.ment</TI        "$tf_      !   if (pent_head (forq!<PARAM>
   NTER>
      print qq!
pent_head (fo;###########################################################################
#                        sub print_tablen                              #
##
###########################################################################
sub print_tabls {
    my $codeect = shift;
    my $database = $q->param('database');
    my $sampltion = $q->param('selelts of     my $sam(codes,$raw_se) {
aw_se)zeros)   prin# GET =~ mminuint_og'see
#   (web-b;
  .cgi  $samp=~ m/^(.*)\/.*$/;
   $path = "$PR$1   print_minier("0 ReT">
 ults of tthe baseto 0ection");
        t qq!<CENTER><H2>En3>T">
 ults of tthe baseto 0ection");
>\n";
         <A HREF="$URL?projload_collection();
=$/$SCF_ECT_DIR/$project/$db/$sase/$selection/$seq_idion/$se.tar.gz">Doad_colf            Archive0;e ViewF = grthe poallection();

       <B>Disp[_idion/$se.tar.gz]</TD><A NTER>
   <P>    print_minisummaryoject,$database,$sampltion);
    $prot_button_bar($project);

   ##########################################################################
#                            sub print_commsummary                     #
##
###########################################################################
sub print_tablsummary   my $project = shift;
    my $database = shift;
    my $selection = shift;
    my $seq_ = "$PROJECT_PATH/$project/$database/$selection/$seq"   open IN, "$code/$SCF_PRY_FILE";

 f         roak "cannot open $c_fi/$SCF_PRY_FILE";

;
        rh_codes ts = $q->codes ts = $(i/$SC ($aut-eode/$SCF_ENTS_FILE"; 

       t qq!<CENT METHOD="get"pos            <INPUER><TABLE CELLER=2 WIDTH="100%9CELLPADDING=3>
 4;
    }
}
header = split /$DELIMITER/,<IN>;
    my @ach (@allfer = s   nt "<P>";TH>$_>
   
      print qq!
';TH>s ts = $>
   '  }
}
headtotal();
    my $id;s = ();

   while (<IN>) {
        my @fields = split /$DELIMITER/;
        $id  @rec,$_;sfields;
    }
    retusfield) {
_ = split{ $b->sum_y of ($b) $a->sum_y of ($a){$rh = s  foreach my $k (ksorted) {
_ = s        my @fieder[$hift @fiel$r      my $tf_oent_headsummary bstr($dl,0odes ts = $k}};er[$},0,10       print "<CENTTR;
        print qq!Try <A HREF="$URL"><Iject=$project&show_sequence=$seq_er[$abase=$database&selection=$selection&soreader[$</TD>\n!;
        }
  ach my $k (kfra_re            print qq!<TR><TIGN="center"><FON$f>\n!;
        }
        print qq!<TD ALI>UT TYPE="hiddradio"E="autoents\n"ton_barLUE="$seqENT                           onClickndow.O$c_('"><Iject=$project&show_tion=$selection&sortents\n"ton_bar=1abase=$database&select$DELq_er[$')           oent_headsummary>\n!;!      print "<CENT/TR;
        }
print "<CENT/T></CENTER>\n!;RM>\n!;
 ";###########################################################################
#                          sub get_highs ts = $q                          #
###########################################################################
sub get_codes ts = $q{ my $seq_ = "$PRt;
    my ($cel%s ts = $,);
    
open COMMENT,ode/$SCF_ENTS_FILE"; 

                roak "cannot open $c_fi/$SCF_ENTS_FILE"; 
;
        e (<COMMENT
        chomp;
        my @ = ();
t /$DELIMITER/;
        $id =s ts = $cords[0 1;
 ords[1]  }
    return \%recos ts = $;###    
    #######################################################################
#                             sub get_sum_y of q                          #
###########################################################################
sub get_sum_y of q{ my $ra_rec y of qPRt;
    my ($ce@a_;
 {rec y of }[1..$#{rec y of }]  my $selecum;
 foreach (@allfi   necum"- F$_;   return \%reecum;
##########################################################################
#                           sub truncodes {
_ts = sp                        #
###########################################################################
#   ACCEPTS a vasequ
#   he commen{
  
#   If thturnads commen{
  
#   the ts = spsequ
umb sphe ificant alig from    RETU (@alence and a onlutoms lookform 
# E.ecti flags If thtust">Sc results of tinsp lareche lareelled from%count = ls RETURNS a reference to an a closlarece, it########################################################################
sub get_codes {
_ts = sp{ my $selection = shift;
    my $seq_base = shift;
    my $sel%count = ls);
    my $id;rteeqbaseq_id,$k);
b;
  _: tet,$ur_e;
}
,$eecti   
open COMMENDE>$c_$sase/$selection/$seq_PRY_FILE";

 
         roak "cannot open $c_f./$sase/$selection/$seq_PRY_FILE";

:";
    t "<CEN$sase/$selection/$seq_PRY_FILE";

    while (<IN>)ENDE>
        chomp;
        my @ eeqbaseplit(/\//,~\|~_);
        if (_id = shift;

 @ eeqbase      if (_id =t = ls{_id = s1;
 \ eeqbase        return \%recoid =t = ls
###########################################################################
#                       sub print_sequp;
os                         #
##  #
###########################################################################
#   PRINTS out the begiction = sh(ctory tha) p;
os   oand aabase and is  If sction ee the C clost_seqC;
os  Bodyfinescribrombelow)an at "<CEthe begiactualm (fo########################################################################
sub print_tabls;
os     my $codeect = shift;
    my $database = $q->param('database');
    my $sampec file->coderds;
}
oject,$database,$sa       i print_minier("0 ReC;
os  aaCction();
tinsabase");
        t_tablsforlels;
os  _bodyoject,$database,$sampec fil   ##########################################################################
#                        print_tablsforlels;
os  _body              #
##  #
###  #######################################################################
#      Ifo_clhtiesca();
tis theddon'ot disple><Fmwhich
otis thform 
#  so  If on'ot disp_hitaluer cad the uner cad s;
os  .  S
#  at "<CEa sforle  If s;
os  .
######################################################################
sub print_tablsforlels;
os  _body   my $project = shift;
    my $db = shift;
    my $seleec file->t;

    print qq!
    <LI>< METHOD="get"> 
  
<INPUT TYPE="hidden" NAME="project" VALUE="$project">
        UT TYPE="hidden" NAME="database" VALUE="$db">
b   <CENTER>
    
   En3>= shDase" VA>\n";
    <SELECTE="datalts of "E=+1>C10      !   if (ach (@al$_ra_rec fil        print '&nb"<OPS{'i>$_unle$aut-dROJECT_PATH/$project/$db/$sele_")  } els  if (t qq!
    </HEADSELECT  
   En3>UT TYPE="submit" NAME="from_tracs;
os  " E="$seq  er c lts for  FORMn";
    <M>
   NTER>
        !   if (t_button_bar($project);

   ##
    #######################################################################
#                        sub princoderds;
}
                          #
##  #
###########################################################################
#   PRINPTS a databtory that
#    PRINTU vasequs...
 directory
# {
  he coatabtory thatbut array of f RETURNS a reference to an a ceay of ########################################################################
sub get_coderds;
}
   my $project = shift;
    my $db = shift;
    my $sel@ cls...
   closehbto $BLAST">
 H/$pr roak "cannot openehbto $BLAST">
 H/$pr;
        oing or DIR,ROJECT_PATH/$project/$db/$se
              roak "cannot open $c_bto $ECT_PATH/$project/$db/$se;
        @ cls...
e->crep (!/^\.\.?$_);rnadbto(DIR))  } ele COM or DIR;  for (my $i=0; _;
  cls...
 0; _> i <= --        unless (/>/)-dROJECT_PATH/$project/$db/$sele cls...
">$he            print(/\ce(  cls...
,$i,1        if (  }
    whil@ cls...
e->t{ $b@ cls...
  return \%rec@ cls...
  ##########################################################################
#                      sub unspaseex {
 d (f_base" VA                     #
###########################################################################
sub _rouaseex {
 d (f_base" VA    my $project = shift;
    my ($seq_ or,$;
  _ or,@groups)   open INDEX, "$PROJECT_PATH/$project/$project.$PROJECT_INDEX_SUFFIX" or 
    croak "cannot open $PROJECT_PATH/$project/$project.$PROJECT_INDEX_SUFFIX:$!";
     while (<INDEX>) {
        chom_ or);
 t /$DE("\/",
  )
}

#    $id  @rec,groups,_ or)$q->p or)neode;
  _ or"
           $code;
  _ orq->p or        return \%r(\@groups)  ###########################################################################
#                       sub print_sequbase" VA_pick                       #
###########################################################################
#   ACCETS out the begibase = $qction/$seq;
 ee thathe commap(/\ca();
########################################################################
sub print_tablbase" VA_pick     my $project = shift;
    my $db =ec groupsntaiseex {
 d (f_base" VA oject);

    if (t_minier("0 ReC;
os  aaDase" VA d;
}roject = s")   print qq!
  ^ <LI>< METHOD="get"> 
 NPTS{'iRL"><IMG
<INPUT TYPE="hidden" NAME="project" VALUE="$project">
        UER>
    
   EE CELLPADDING=5><T3>
        <TIGN="centr {
 ONT SIZE="-1"><A HDase" VA:</FONT></TD>
        <FONT SIZE=-2><><A HRSELECTE="data
ase" VAL ^   if (ach (@aldb = sha_rec groups)       print '&nb"<OPS{'i>$db
        }       print qq!
  ^ <LI><DSELECT  
   E/FONT></TD>
        <FOGN="centr {
 ONT SIZE="-1"><A HSe_nam N#  :</FONT></TD>
        <FONTT TYPE="datace_name/i) "E=+1>C15D></TR>
        <TD COLSPAN=2><F4GN="center"><FONT SIZE="-1"4<A H     UT TYPE="hiddit" NAME="from_tracdb_pick  " E="$seq  Ret {
itaDasetf_      U/FONT></TD
</TD></TR></TABLE></CE
    <M>
   
    <MER>
    
   EnRE=+1>C1  </BODY></HT </HEAD>
    ^;###########################################################################
#                        sub print_tabler                           #
##  #
###########################################################################
#   ACCETS out the begi pageer     direWeb-t Commlogo (my  somye that########################################################################
sub print_hits r {
    my $seq_tit shift;
     print qq!Content-type: text/html

    <HTML>
    <HEAD>
    <TITLE>BlasI WEB_Beb-t Com:q_tit sTLE>!;
     my $$q->param('comm_tracs;
os  {
        print_com(coderadio_ction/_st>
  ())  } els  if (t qq!
     </HEAD>
     <BODY BGCOLOR="#ffffff">
    <CENTER>
    
   LE BORDER=4 WIDTH=500>
   <TH COL  
   LE BOR>
        <TIHREF="$URL"><IMG SRC="$LOGO" BOR         priER=0 
   "NHGRI WEB_BLA-T">
   </TD>
        ></TABLE></CE
    <M/TR>
   BLE></CE
    <MER>
    
   LP}

###########################################################################
#                      sub princoderadio_ction/_st>
                   #
##  #
###########################################################################
#   ACCETS out the begi/trast>
   funn,$seq Ww.O$c_, coataalled from a pobeg hencetable, itm 
#  n at commament window
###########################################################################
sub princoderadio_ction/_st>
   { return \%re'
<SCRIPT LANGUAGE=Java"Script>
  1.B><A!--den em a poold brows  s
<SCR//s is dfunn,$se accep spsequ=~ mh
#  l autob  aaed f
<SCR//st
#  b-b;
  .cgie tshforman idu
umb spthformsequcod method
<SCR//sthe ted ans aaow and the popuent windbox coataallbuiltsettpopuCGI if (aunn,$se ow.O$c_(a        prinow.closo$c_(a,oents\n";dow {
 ","he {
 =270,width=330,status=no,toolbar=no,ctory
# {
 =no,s\nubar=no,loca();
=no,st>ollbars=yes")  } els <SCR//sc_b st>
   en form--E
    <MPT>!;
 ';
##########################################################################
#                           sub trunt_button_bar($pr                #
##  #
### ########################################################################
#   PRINTS out the beginn_bar $pr ae begino_bamthe  somye tha This iginn_barsmh
#  lndedatabding the woata thathe commap(/\ca();
 comm Thisus   n one########################################################################
sub print_hitson_bar($pr       pproject = shift;
    my $$db = shifparam('database');
    my $$seq = "";
param('show_sequence');
  $q->param('show_e_name/i)     my $$seq = ion = $q->param('selection') || shifparam('selelts of                         hifp_
}
e";
      print qq!
  ^ <LI> LP}Y R>UB        UER>
         EE CELLPADD=2>C5><T0LPADDING=5><T0       EE        EEIGN="center">
         REF="$URL"><IMG SRC="$LOGOWB_HOME_BUTTON"DER=0><TR></TD^   if ($$q->p= ion = $qexpeno_matche         se {
$q->param('comm_tracs;
os  {
        prinnt qq!
  ^ <LI>     REF="$URL"><I\ject=$project&sho\abase=$databb\&_tracdb_pick  =1           < SRC="$LOGODB_HOME_BUTTON"DER=0><TR></TD^       se {
$q->param('comm_sequence');
  $q->param('show_e_name/i)           prinnt qq!
  ^ <LI>     REF="$URL"><I\ject=$project&sho\abase=$databb\&_tracdb_pick  =1           < SRC="$LOGODB_HOME_BUTTON"DER=0><TR></TD <LI>     REF="$URL"><I\ject=$project&sho\abase=$databb&lts of lection&sort_tracs;
os  =1           < SRC="$LOGOHITS_E CEL_BUTTON"DER=0><TR></TD^       se   print qq!
  ^ <LI> LEF="$URLmailto:$ADMIN_EMAIIMG SRC="$LOGOEMAII_BUTTON"DER=0><TR></TD <LI> ></TR></TABLE>
         NTER>\n!;R R>UB  DY></HTML>!;
}^
###########################################################################
#                       sub prinload_collection();
                        #
###########################################################################
sub dispload_collection();
 { my $autoention();
scf)load_colhifparam('databoad_collection();
'
       if (t qq!
"Loca();
:toention();
scf)load_col\n
     ##########################################################################
#                            sub prinint_data($pr                   #
##  #
###########################################################################
#   ACCHere's aaans 0 itmake prrat closbegibasetains bad nothformon_ ``word''  If s;('dc>
 s (alphabeti;sfi
umeri;sfithe un{
 es">Sc)raw hyphc_, rray   winific,  popudot. ########################################################################
sub unspact_data($pr   my $seq_tacome0_baseplit;
    my ($seq_act_date0_base)   my $$q->ptacome0_basepl~ /^([-\@\w.]+)$
             $codeact_date0_base$PR$1 ### abase now act_date0 } else {
        prink "cannBolhDasetinsat_date0_base";          return \%reeact_date0_base  ##########################################################################
#                            sub print_comm

                          #
##
###########################################################################
sub print_tabl

     my $project = shift;
    my $db =

   ifparam('data

  ')   open INDE>!;
PROJECT_PATH/$project/$proj";
  
    croa   prink "cannot open $PROJECT_PATH/$project/$proj";
 ;
        t qq!
"ent-type: text/html

  \n
    while (<I(L>
           print_com  } els <SCRexit  ####get_staden_env();
   
p;
  ({'MACHINE'}-bin if`u
#   -sr | hedd's/ /-/g;s/SunOS-4.*/sun/;s/IRIX.*/sgi/;s/SunOS-5.*/solaris/;s/OSF.*/alpha/;s/Linux.*/linux/'`)  {'STADENROE>
  "/bin{'STADENROOT'}/$ENVe, its"  {'STADENROUSER "/bin{'STADENROOT'}/$ENVus  base"; {'STADENROHELP "/bin{'STADENROOT'}/$ENVhelp"; {'STADENROLIB "/bin{'STADENROOT'}/$ENVlib    {'PATH'} = "/bin{'PATH'} = ":{'STADENROOT'}/$ENV{'MACHINE'}-bin";
 :{'STADENROOT'}/$ENVenclibs-{'MACHINE'}-bin";
     {'PATHLD_LIBRFILE'} = "/bin{'PATENROLIBNV{'MACINE'}-bn";
 a {
 :{'STALD_LIBRFILE'} =}"; {'STADLD_LIBRFILE'} = "/bin{'PATENROLIBNV{'MACINE'}-bn";
 a {
 "; {'STADEEQEDT "/bi'x><Fm -e vi'; {'STADET>!BS "/bin{'STADENROE>
  "/PERCPTRON.WTS"; {'STADEUK>!BS "/bin{'STADENROE>
  "/>!BSEUKAR.WTS"; {'STAD ouRONS "/bin{'STADENROE>
  "/ ouRON.WTS"; {'STADECECTMS "/bin{'STADENROE>
  "/PROKECTMS.WTS"; {'STADRENZYM4 "/bin{'STADENROE>
  "/>ENZYM.4"; {'STADRENZYM6 "/bin{'STADENROE>
  "/>ENZYM.6"; {'STADRENZYMAL "/bin{'STADENROE>
  "/>ENZYM.ALL"; {'STADNIPMARG "/bin{'STADENROE>
  "/NIP.MRG"; {'STADNIPFMARG "/bin{'STADENROE>
  "/NIPF.MRG"; {'STADSIPMARG "/bin{'STADENROE>
  "/SIP.MRG "; {'STADECTTMAT "/bin{'STADENROE>
  "/PROTMAT.DAT "; {'STADSAPMARG "/bin{'STADENROE>
  "/SAP.MRG"; {'STADBAPMARG "/bin{'STADENROE>
  "/BAP.MRG";  {'PATHDAPMARG "/bin{'STADENROE>
  "/DAP.MRG";  {'PATHTAGDB'} = "/bin.:{'STAHOME":{'STAENROE>
 }";  {'PATHTAGDB "/binTAGDB";  {'PATHGTAGDB "/binGTAGDB:{'STAHOME"/GTAGDB:{'STAENROE>
 }/GTAGDB"; {'STADEIPMARG "/bin{'STADENROE>
  "/PIP.MRG "; {'STADECTTGRP "/bin{'STADENROE>
  "/PROTEIN.GRP "; {'STADECTTALL "/bin{'STADENROE>
  "/PROTEIN.ALL "; {'STADROBSON "/bin{'STADENROE>
  "/>OBSON.WTS "; {'STADMEPMARG "/bin{'STADENROE>
  "/MEP.MRG"; {'STADALU="frS "/bin{'STADENROE>
  "/alus/s...
"; {'STADALUDIR "/bin{'STADENROE>
  "/alus"; {'STADGIPMEM "/bin{'STADENROHELP "/gip_help"; {'STADHELPENROOT "/bin{'STADENROHELP "/en_env(help"; {'STADM13MP18_VPATOR "/bin{'STADENROUSER "/m13mp18.vec"; {'STADEUC18_VPATOR "/bin{'STADENROUSER "/puc18.vec"; {'STADBLUE_VPATOR "/bin{'STADENROUSER "/blue.vec"; {'STADEROSITE "/bin:nfs/al/pub$seqpub$seqenclibs/ectsite"; {'STADEROSITEP "/bin:nfs/al/pub$seqpub$seqenclibs/ectsite/pats    {'PATH'ROSITE="frS "/bin:nfs/al/pub$seqpub$seqenclibs/ectsite/pctsite.
#     {'PATHX";

SEARCH'} = "/bin{'PATENROHELP}/%N%S:{'STAENROE>
 }/%N%S:{'STAX";

SEARCH'} =}"; {'STADDIGITIZER "/bin/dev/ttyb"; {'STADEREGAP'}/$EN/bin{'STADENROOT'}/$ENVpregap"; {'STADTCLUTILS_LIBRFIL "/bin{'STADENROOT'}/$ENVlib/tk_utils"; {'STADTKUTILS_LIBRFIL "/bin{'STADENROOT'}/$ENVlib/tk_utils"; {'STADGAP_LIBRFIL "/bin{'STADENROOT'}/$ENVlib/gap"; {'STADSIP_LIBRFIL "/bin{'STADENROOT'}/$ENVlib/sip"; {'STADEEQLIB_LIBRFIL "/bin{'STADENROOT'}/$ENVlib/snclib    ##!NO!SUB